#ifndef IDT_H
#define IDT_H

#include "vm86types.h"

typedef uint32 uintptr;

#pragma pack(push, 1)
typedef struct InterruptGate
{
    uint16 Offset15_0;
    uint16 Selector;
    uint8 Zero;
    uint8 Type : 4;
    uint8 S : 1;
    uint8 DPL : 2;
    uint8 P : 1;
    uint16 Offset31_16;
} InterruptGate;

typedef InterruptGate TrapGate;
typedef InterruptGate CallGate;

typedef struct IDTEntry
{
    union
    {
        uint32 Value[2];
        InterruptGate Interrupt;
        TrapGate Trap;
        CallGate Call;
    };
} IDTEntry;

typedef struct IDTDescriptor
{
    uint16 Limit;
    IDTEntry *Entries;
} IDTDescriptor;
#pragma pack(pop)

void idtInitialize();
void idtSetInterruptEntry(uint8 i, uint16 sel, uintptr offset, uint8 type);

#endif // IDT_H

